using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Microsoft.SPOT.Emulator.MFBook
{
    public partial class LCDPanelForm : Form
    {
        LCDPanelComponent myComponent;             // Handle to the emulator component of the LCD sample

        private delegate void UpdateDisplay_uiLcdSampleForm(Bitmap bmp);     // Used to update bmp to ui from different thread

        /// <summary>
        /// Constructor for the sample UI
        /// </summary>
        /// <param name="lcdSampleComponent">Emulator component handling all the LCD processing</param>
        public LCDPanelForm(LCDPanelComponent lcdSampleComponent)
        {
            // Initializing the component on the UI form
            InitializeComponent();

            // Keeping the handle of the emulator component taking care of the LCD events
            myComponent = lcdSampleComponent;
        }

        /// <summary>
        /// Updating the picture on the form
        /// </summary>
        /// <param name="bmp">Bitmap of the LCD</param>
        public void UpdateDisplay(Bitmap bmp)
        {
            if (this.InvokeRequired)
            {
                this.Invoke(new UpdateDisplay_uiLcdSampleForm(UpdateDisplay), bmp);
            }
            else
            {
                pbLcdDisplay.Image = bmp;
            }
        }

        /// <summary>
        /// Fitting the picture box so it fills the form
        /// </summary>
        public void FitImage()
        {
            this.pbLcdDisplay.Location = new Point(this.Top, this.Left);
            this.pbLcdDisplay.Size = new Size(this.Width-this.Left, this.Height-this.Top);
//            this.pbLcdDisplay.ClientSize = new System.Drawing.Size(this.Emulator.Width, this.Emulator.Height);
        }
     }
}